

-- To Use this script:
-- 1) Press CTRL+SHIFT+M to replace template parameters.
-- 2) specify the name of the DB you want to offline/copy.
-- 3) Press OK to finish parameter replacement
--		(For more info on using templates/parameters see www.sqlservervideos.com/tmpl

-- 4) Run the top query to get the names of all data files within your database. 
--		(You may want to copy/paste these in a text/file etc. for reference once your DB is offline/detached)

-- 5) ONLY run the second query in this sample if you're sure that it won't disrupt key operations
--		as it will find all connections to the targeted database and kill them - following which it
--		will take your database offline.


USE <dbName,sysname,default>
GO

SELECT file_id,name,physical_name 
FROM sys.database_files


/*

USE master
GO

DECLARE killer CURSOR LOCAL READ_ONLY FAST_FORWARD FOR
SELECT 
	spid
FROM 
	dbo.sysprocesses
WHERE
	dbid = DB_ID('<dbName,sysname,default>')	

DECLARE @spid int
DECLARE @sql nvarchar(20)

OPEN killer

FETCH NEXT FROM killer INTO @spid
WHILE @@FETCH_STATUS = 0 BEGIN
	
	SET @sql = N'KILL ' + CAST(@spid as nvarchar(5))
		
	EXEC sp_executesql @sql
	
	FETCH NEXT FROM killer INTO @spid
END

CLOSE killer
DEALLOCATE killer
GO

ALTER DATABASE <dbName,sysname,default>
SET OFFLINE

*/
